% Main simulation loop
while time < Tend
    
    % THE VARIABLE mssg WILL CONTAIN THE OUTPUT VALUES FROM HAWC2
    StringFromHawc=[];
    
    while (isempty(StringFromHawc))
        StringFromHawc = jtcp('READ',JTCPOBJ);
        StringFromHawc = char(StringFromHawc);
    end
    % Replaces NaN with 0 if needed
    StringFromHawc = regexprep(StringFromHawc, 'NAN', '0');
    % Convert string to array
    ArrayFromHawc = str2num(StringFromHawc);
    % Remove first entry from array
    ArrayFromHawc = ArrayFromHawc(2:end);
    
    time = ArrayFromHawc(1)
    
    % Pitch actuator sensors
    th = ArrayFromHawc(32)*180/pi;
    dth = ArrayFromHawc(33)*180/pi;
    d2th = ArrayFromHawc(34)*180/pi;
    % Generator sensors
    Qg = ArrayFromHawc(27);
    dQg = ArrayFromHawc(28);
    Pe = ArrayFromHawc(31)*1e3;
    
    % Driveshaft sensors
    omega_r = -ArrayFromHawc(2);
    omega_g = -ArrayFromHawc(3)*ProblemParms.Ng;
    phi_delta = -ArrayFromHawc(6);
    % Nacelle fore-aft displacement sensors
    psi_t = ArrayFromHawc(7);
    dpsi_t = ArrayFromHawc(8);
    d2psi_t = ArrayFromHawc(9);
    % Wind speed at nacelle sensor
    vy = ArrayFromHawc(37);
    % Torque on driveshaft at rotor side
    Qr = -ArrayFromHawc(25)*1000;
    
    [U,Xpid,time_old,Ts] = pid_wt(U,Xpid,time_old,Ts,omega_g,time,ProblemParms);
    
    % Displays control signals if they are NaN, inf etc.
    if ~isreal(U)
        U
    end
    
    ArrayToHawc = zeros(40,1);
    
    ArrayToHawc(1) = U(1)*pi/180;
    ArrayToHawc(2) = U(1)*pi/180;
    ArrayToHawc(3) = U(1)*pi/180;
    ArrayToHawc(4) = U(2);
    
    % % %     PlotTimeInterval = 1; % At what time intervals is ths variables plotted
    % % %     % plot data from HAWC2 directly in Matlab
    % % %     if 1 && time>0 && round((time/PlotTimeInterval)*100)==round(time/PlotTimeInterval)*100
    % % %         figure(1)
    % % %         subplot(3,2,1); plot(time,vy,'.'); hold on;
    % % %         title('Wind Speed')
    % % %         subplot(3,2,3); plot(time,dpsi_t,'.'); hold on;
    % % %         title('Nacelle Velocity')
    % % %         subplot(3,2,5); plot(time,th,'.'); hold on;
    % % %         title('Pitch angle')
    % % %
    % % %         subplot(3,2,2); plot(time,omega_g,'.'); hold on;
    % % %         title('Generator Speed')
    % % %         subplot(3,2,4); plot(time,Pe,'.'); hold on;
    % % %         title('Generator Power')
    % % %         subplot(3,2,6); plot(time,Qg,'.'); hold on;
    % % %         title('Generator Torque')
    % % %     end
    
    
    % THE VARIABLE BACK TO HAWC2 SHOULD BE PLACED IN THE SAME ORDER AS IN THE HTC FILE
    % IMPORTANT THE STRING SHOULD END WITH AN ASTERIX THE *
    StringToHawc = [sprintf('%0.12f;',ArrayToHawc) '*'];
    jtcp('WRITE',JTCPOBJ,int8(StringToHawc));
    
end

