#include<windows.h>
#include<stdio.h>
#include "pid_wt_matlab.h"

/* Global flag to indicate if MCR is initialized */
int MCRrunning=FALSE;
int FIRSTRUN=TRUE;
// System size


double PI = 3.141592653589793;

float GearRatio;

// To MATLAB
mxArray *m_in1_U_old, *m_in2_X_old, *m_in3_time_old, *m_in4_Ts, *m_in5_omega_g, *m_in6_time;

mxArray *m_in7_ProblemParms=NULL;

// From MATLAB
mxArray *m_out1_U_old=NULL;
mxArray *m_out2_X_old=NULL;
mxArray *m_out3_time_old=NULL;
mxArray *m_out4_Ts=NULL;

double *c_in1_U_old;
double *c_in2_X_old;
double *c_in3_time_old;
double *c_in4_Ts;
double *c_in5_omega_g;
double *c_in6_time;

double *c_out1_U_old=NULL;
double *c_out2_X_old=NULL;
double *c_out3_time_old=NULL;
double *c_out4_Ts=NULL;


int wmlfHpid_wt(void);
int wmlfHpid_wt_start(void);

void pid_wt_destroy(void);
int pid_wt_init(void);

int isMCRrunning(void);
void terminateMCR(void);

/* Function handle to the wrapper functions in the wrapper DLL (level2.c) */
/*typedef int ( *h_w_mlfun) (double* data, int size, double** output2d);
 * typedef int ( *h_w_mlterm)(void);*/

/* Handles to wrapper M functions */
/*h_w_mlfun wh_fun;
 * h_w_mlterm wh_term;
 *
 * HINSTANCE hdll;*/

BOOL APIENTRY DllMain(HINSTANCE hInst     /* Library instance handle. */ ,
        DWORD reason        /* Reason this function is being called. */ ,
        LPVOID reserved     /* Not used. */ ) {
    switch (reason) {
        case DLL_PROCESS_ATTACH:
            break;
            
        case DLL_PROCESS_DETACH:
            pid_wt_destroy();
            break;
            
        case DLL_THREAD_ATTACH:
            break;
            
        case DLL_THREAD_DETACH:
            break;
    }
    
    /* Returns TRUE on success, FALSE on failure */
    return TRUE;
}

void pid_wt_destroy(void) {
    //printf("\nattempt hctrl4 var's destroyed");
    
    free(c_in1_U_old);
    free(c_in2_X_old);
    free(c_in3_time_old);
    free(c_in4_Ts);
    free(c_in5_omega_g);
    free(c_in6_time);
    
    free(c_out1_U_old);
    free(c_out2_X_old);
    free(c_out3_time_old);
    free(c_out4_Ts);
    //printf("\nc var's destroyed");    
    /* Clean up MATLAB variables */
    /*mxDestroyArray(m_in1_U);
    mxDestroyArray(m_in2_X_hat_k);
    mxDestroyArray(m_in3_regmode);
    mxDestroyArray(m_in4_r_old);
    mxDestroyArray(m_in5_r_switched);
    mxDestroyArray(m_in6_time_old);
    mxDestroyArray(m_in7_Y);
    mxDestroyArray(m_in8_time);
    printf("\nm1 var's destroyed");    
    mxDestroyArray(m_out1_U);
    mxDestroyArray(m_out2_X_hat_k);
    mxDestroyArray(m_out3_regmode);
    mxDestroyArray(m_out4_r_old);
    mxDestroyArray(m_out5_r_switched);
    mxDestroyArray(m_out6_time_old);
    mxDestroyArray(m_out7_Y_hat_k);
    mxDestroyArray(m_out8_iter);
    printf("\nm2 var's destroyed");    
    mxDestroyArray(m_in9_ProblemParms);*/
    //printf("\nm3 var's destroyed");    
    //printf("\n hctrl terminate");
    //hctrl4matlabTerminate();
    //printf("\n app terminate");
    //mclTerminateApplication();
    //printf("\n app terminated");
    // terminateMCR();
}

int pid_wt_init(void) {
    //int i;
    int returnval = TRUE;
    int nargout;
    
    mxArray *m_GearRatio=NULL;
            
    double *c_GearRatio=NULL;
            
    
	c_GearRatio=(double *)malloc(1*sizeof(double));
    
    /* Start MCR, load library if not done already */
    returnval=isMCRrunning();
    
    nargout = 2;
    
    returnval=mlfPid_wt_start(nargout, &m_in7_ProblemParms, &m_GearRatio);
    
    memcpy(c_GearRatio, mxGetPr(m_GearRatio), 1*sizeof(double));

    GearRatio = (float)(*c_GearRatio);
    
    mxDestroyArray(m_GearRatio);
    
    free(c_GearRatio);  
    
    c_in1_U_old=(double *)malloc(2*sizeof(double));
    c_in2_X_old=(double *)malloc(2*sizeof(double));
    c_in3_time_old=(double *)malloc(1*sizeof(double));
    c_in4_Ts=(double *)malloc(1*sizeof(double));
    c_in5_omega_g=(double *)malloc(1*sizeof(double));
    c_in6_time=(double *)malloc(1*sizeof(double));
    
    c_out1_U_old=(double *)malloc(2*sizeof(double));
    c_out2_X_old=(double *)malloc(2*sizeof(double));
    c_out3_time_old=(double *)malloc(1*sizeof(double));
    c_out4_Ts=(double *)malloc(1*sizeof(double));
    
    // Assign U
	 // [U_old,X_old,time_old,Ts] = pid_wt(U_old,X_old,time_old,Ts,omega_g,time,ProblemParms)	 	
    *(c_in1_U_old+0) = 0.0;
    *(c_in1_U_old+1) = 4.0e4;
    
    *(c_in2_X_old+0) = 0.0;
    *(c_in2_X_old+1) = 0.0;

    *(c_in3_time_old) = 0.0;

    *(c_in4_Ts) = 0.0;	
	
    *(c_in5_omega_g) = 0.0;

    *(c_in6_time) = 0.0;
	

    

    

    
    //printf("hctrl4 var's initialized");
    
    return returnval;
}
void pid_wt(int na, float inpvec[40], int nb, float outvec[40]) {
    
/*
    int returnval;
*/
    int resultofMfun=FALSE;
/*
    int nargout;
*/
    
    if (FIRSTRUN == TRUE) {
        pid_wt_init();
        FIRSTRUN = FALSE;
    }
    
    *c_in6_time = (double)(inpvec[0]);
    
	*(c_in5_omega_g) = (double)(-inpvec[2]*GearRatio);
	
    //if(*c_in3_time_old < *c_in8_time) {
        
        /* Call this function with the expected input arguments */
        resultofMfun= wmlfPid_wt();//(&c_out1_U, &c_out2_X_hat_k, &c_out3_regmode, &c_out4_r_old, &c_out5_r_switched, &c_out6_time_old, &c_out7_Y_hat_k, &c_out8_iter,
        //c_in1_U, c_in2_X_hat_k, c_in3_regmode, c_in4_r_old, c_in5_r_switched, c_in6_time_old, c_in7_Y, c_in8_time);

			 // [U_old,X_old,time_old,Ts] = pid_wt(U_old,X_old,time_old,Ts,omega_g,time,ProblemParms)
        
        memcpy(c_in1_U_old, c_out1_U_old, 2*sizeof(double));
        memcpy(c_in2_X_old, c_out2_X_old, 2*sizeof(double));
        memcpy(c_in3_time_old, c_out3_time_old, 1*sizeof(double));
        memcpy(c_in4_Ts, c_out4_Ts, 1*sizeof(double));
    //}
    //else {
        /*
         * Y = [omega_r omega_g phi_delta 0 0 0 ...
         * psi_t dpsi_t d2psi_t ...
         * th dth d2th ...
         * Qg dQg ...
         * Pe Qr 0 0 0 vy]';
         */
        
        // Driveshaft sensors; rotor and generator speed and drive-shaft torsion

        
    //}
    // Control signals
    outvec[0] = (float)(*(c_out1_U_old+0)*PI/180.0); // theta1_ref
    outvec[1] = (float)(*(c_out1_U_old+0)*PI/180.0); // theta2_ref
    outvec[2] = (float)(*(c_out1_U_old+0)*PI/180.0); // theta3_ref
    outvec[3] = (float)(*(c_out1_U_old+1)); // Qg_ref


}

/*-----------------------------------------------------------------------*/

/* Each function wrapper should call this function first */
int isMCRrunning(void) {
    
    int result;
    
    if(MCRrunning){
        /*We have already initialized the MCR and initialized the MATLAB library DLL in a previous call */
        return TRUE;
    }
    else{
        /* Start the MCR */
        mclmcrInitialize();
        result = mclInitializeApplication(NULL, 0);
        
        if(result) {
            //printf("\nSucceded to initialize MCR\n");
        }
        else {
            printf("\nFailed to initialize MCR\n");
            return result;
        }
        
        /* Initialize the MATLAB generated DLL */
        //printf("Attempting to initialze MATLAB file");
        result = pid_wt_matlabInitialize();
        if(result) {
            //printf("\nSucceded to initialize Library\n");
            MCRrunning=TRUE;
            return result;
        }
        else {
            printf("\nFailed to initialize Library\n");
            return result;
        }
    }
    
}

/*-----------------------------------------------------------------------*/

/*Function to terminate the MCR*/
void terminateMCR(void) {
    pid_wt_matlabTerminate();
    mclTerminateApplication();
}

/*-----------------------------------------------------------------------*/

/* Wrapper for level 1 function exported by the MATLAB generated DLL         *
 * This function converts C data to MATLAB data, calls the MATLAB generated  *
 * function in level1.dll and then converts the MATLAB data back into C data */

int wmlfPid_wt(void)//(double** c_out1_U, double** c_out2_X_hat_k, double** c_out3_regmode, double** c_out4_r_old, double** c_out5_r_switched, double** c_out6_time_old, double** c_out7_Y_hat_k, double** c_out8_iter,
//double* c_in1_U, double* c_in2_X_hat_k, double* c_in3_regmode, double* c_in4_r_old, double* c_in5_r_switched, double* c_in6_time_old, double* c_in7_Y, double* c_in8_time)
{
    
    int nargout=4;
    int returnval;
    
    /* Start MCR, load library if not done already */
    returnval=isMCRrunning();
    if(!returnval) { return returnval; }
    
    /* Convert C data to MATLAB data */
    /* IMPORTANT: this has to be done after ensuring that the MCR is running */
    m_in1_U_old = mxCreateDoubleMatrix(2, 1, mxREAL);
    m_in2_X_old = mxCreateDoubleMatrix(2, 1, mxREAL);
    m_in3_time_old = mxCreateDoubleMatrix(1, 1, mxREAL);
    m_in4_Ts = mxCreateDoubleMatrix(1, 1, mxREAL);
    m_in5_omega_g = mxCreateDoubleMatrix(1, 1, mxREAL);
    m_in6_time = mxCreateDoubleMatrix(1, 1, mxREAL);
    
    // Copy from C arrays to MATLAB arrays
    memcpy(mxGetPr(m_in1_U_old), c_in1_U_old, 2*sizeof(double));
    memcpy(mxGetPr(m_in2_X_old), c_in2_X_old, 2*sizeof(double));
    memcpy(mxGetPr(m_in3_time_old), c_in3_time_old, 1*sizeof(double));
    memcpy(mxGetPr(m_in4_Ts), c_in4_Ts, 1*sizeof(double));
    memcpy(mxGetPr(m_in5_omega_g), c_in5_omega_g, 1*sizeof(double));
    memcpy(mxGetPr(m_in6_time), c_in6_time, 1*sizeof(double));
    
    /* Call the M function */
	 // [U_old,X_old,time_old,Ts] = pid_wt(U_old,X_old,time_old,Ts,omega_g,time,ProblemParms)
	 
    returnval=mlfPid_wt(nargout, &m_out1_U_old, &m_out2_X_old, &m_out3_time_old, &m_out4_Ts,
            m_in1_U_old, m_in2_X_old, m_in3_time_old, m_in4_Ts, m_in5_omega_g, m_in6_time,
            m_in7_ProblemParms);
    /*Convert returned  MATLAB data to C data */
    
    
    // Copy from MATLAB arrays to C arrays
    memcpy(c_out1_U_old, mxGetPr(m_out1_U_old), 2*sizeof(double));
    memcpy(c_out2_X_old, mxGetPr(m_out2_X_old), 2*sizeof(double));
    memcpy(c_out3_time_old, mxGetPr(m_out3_time_old), 1*sizeof(double));
    memcpy(c_out4_Ts, mxGetPr(m_out4_Ts), 1*sizeof(double));
    
    
    
    return returnval;
}

